package cn.itheima;

import java.util.ArrayList;
import java.util.List;

import javax.xml.parsers.SAXParser;
import javax.xml.parsers.SAXParserFactory;

import org.xml.sax.Attributes;
import org.xml.sax.ContentHandler;
import org.xml.sax.Locator;
import org.xml.sax.SAXException;
import org.xml.sax.XMLReader;
import org.xml.sax.helpers.DefaultHandler;

public class Demo1 {
	public static void main(String[] args)throws Exception {
		//1.ȡsax
		SAXParserFactory parserFactory = SAXParserFactory.newInstance();
		//2.ȡsax
		SAXParser parser = parserFactory.newSAXParser();
		//3.ȡxmlȡ
		XMLReader reader = parser.getXMLReader();
		//4.ע¼
		MyContentHandler4 handler = new MyContentHandler4();
		reader.setContentHandler(handler);
		//5.ȡxmlļ
		reader.parse("book.xml");
		
		List list = handler.getBookList();
		System.out.println(list.size());
	}
}


class MyContentHandler4 extends DefaultHandler{
	List <Book> bookList = new ArrayList<Book>();
	String eleName = "";
	public List getBookList(){
		return bookList;
	}
	
	@Override
	public void characters(char[] ch, int start, int length)
			throws SAXException {
		if("".equals(eleName)){
			Book book = bookList.get(bookList.size()-1);
			book.setBookName(new String(ch,start,length));
		}
		if("".equals(eleName)){
			Book book = bookList.get(bookList.size()-1);
			book.setAuth(new String(ch,start,length));
		}
		if("ۼ".equals(eleName)){
			Book book = bookList.get(bookList.size()-1);
			book.setPrice(new String(ch,start,length));
		}
	}

	@Override
	public void endElement(String uri, String localName, String name)
			throws SAXException {
		eleName = "";
	}

	@Override
	public void startElement(String uri, String localName, String name,
			Attributes attributes) throws SAXException {
		if("".equals(name)){
			Book book = new Book();
			String pub = attributes.getValue(0);
			book.setPub(pub);
			bookList.add(book);
		}
		if("".equals(name)){
			eleName = "";
		}
		if("".equals(name)){
			eleName = "";
		}
		if("ۼ".equals(name)){
			eleName = "ۼ";
		}
	}
	
	
}

//jaxpsaxʽȥԪص
class MyContentHandler3 extends DefaultHandler{

	@Override
	public void startElement(String uri, String localName, String name,
			Attributes attributes) throws SAXException {
		//ע⣺ʹһǩκԣattributesҲnullһûзװκԵattributes
		//жһǩǷԵʱattributes == null Ӧattributes.getLength() == 0
		if("".equals(name)){
			if(attributes.getLength() == 0){
				System.out.println("ǩû");
			}
		}
		//һָǩϵ
		if("".equals(name)){
			for(int i = 0; i<attributes.getLength();i++){
				System.out.println(attributes.getQName(i)+""+attributes.getValue(i));
			}
		}
	}
	
}

//jaxpsaxʽȡָڵ
class MyContentHandler2 extends DefaultHandler{

	String eleName = "";
	int cont = 0;
	@Override
	public void characters(char[] ch, int start, int length)
			throws SAXException {
		if("".equals(eleName) && cont == 1){
			System.out.println(new String(ch,start,length));
		}
	}

	@Override
	public void endElement(String uri, String localName, String name)
			throws SAXException {
		if("".equals(name)){
			eleName = "";
		}
	}

	@Override
	public void startElement(String uri, String localName, String name,
			Attributes attributes) throws SAXException {
		if("".equals(name)){
			cont++;
			eleName = "";
		}
	}
	
}

//jaxpsaxʽнڵ
class MyContentHandler implements ContentHandler{

	//ĵʼʱɽ
	public void startDocument() throws SAXException {
		System.out.println("xmlʼ");
	}
	

	//ֿʼǩʱ
	public void startElement(String uri, String localName, String name,
			Attributes atts) throws SAXException {
		System.out.println("ֿʼǩ"+name);
	}
	
	//ֱǩʱ
	public void characters(char[] ch, int start, int length)
		throws SAXException {
		System.out.println("һı"+new String(ch,start,length));
	}
	
	//ֽǩʱ
	public void endElement(String uri, String localName, String name)
		throws SAXException {
		System.out.println("ֽǩ"+name);
	}
	//ĵʱɽ
	public void endDocument() throws SAXException {
		System.out.println("xml");
	}



	public void endPrefixMapping(String prefix) throws SAXException {
		// TODO Auto-generated method stub
		
	}

	public void ignorableWhitespace(char[] ch, int start, int length)
			throws SAXException {
		// TODO Auto-generated method stub
		
	}

	public void processingInstruction(String target, String data)
			throws SAXException {
		// TODO Auto-generated method stub
		
	}

	public void setDocumentLocator(Locator locator) {
		// TODO Auto-generated method stub
		
	}

	public void skippedEntity(String name) throws SAXException {
		// TODO Auto-generated method stub
		
	}

	



	public void startPrefixMapping(String prefix, String uri)
			throws SAXException {
		// TODO Auto-generated method stub
		
	}
	
}